from math import pi

import pygame
from numpy import *

from constants import *
from objects import *

def getNumDisksForWorld(iLevel):
	return len(levelList[iLevel]["diskPos"])

def getDiskPosForWorld(iLevel, iDisk):
	return levelList[iLevel]["diskPos"][iDisk]
	
def getWorldX(iLevel):
	return (SCREEN_RES[0] / VECTOR_ARROW_SPACING) - 1

def getWorldY(iLevel):
	return (SCREEN_RES[1] / VECTOR_ARROW_SPACING) - 1
	
def getObjectListForLevel(iLevel):
	return levelList[iLevel]["objectList"]	
	
def getWallListForLevel(iLevel):
	return levelList[iLevel]["wallList"]	
	
def getWinPosForLevel(iLevel):
	return levelList[iLevel]["winPos"]	
		
	
levelList = [None for i in range(NUM_LEVELS)]
		
levelList[0] = {"diskPos"    : ((SCREEN_RES[0] / 2, BORDER_WIDTH + DISK_RADIUS),),
				"objectList" : [Repeller((SCREEN_RES[0] / 2, SCREEN_RES[1] / 2), 110, False),
								DefaultGravity()],
				"wallList"   : [],
				"winPos"	 : roundToGap(array((SCREEN_RES[0] / 2, SCREEN_RES[1] / 2))),
				}
				
levelList[1] = {"diskPos"    : ((SCREEN_RES[0] / 2, BORDER_WIDTH + DISK_RADIUS),),
				"objectList" : [Repeller((2 * VECTOR_ARROW_SPACING, SCREEN_RES[1] / 2), 110, False),
								DefaultGravity()],
				"wallList"   : [],
				"winPos"	 : roundToGap(array((2 * VECTOR_ARROW_SPACING, SCREEN_RES[1] / 2))),
				}			

levelList[2] = {"diskPos"    : ((SCREEN_RES[0] / 2, BORDER_WIDTH + DISK_RADIUS),),
				"objectList" : [Repeller((2 * VECTOR_ARROW_SPACING, SCREEN_RES[1] / 2 - VECTOR_ARROW_SPACING), 100, False),
								GravityWell((7 * SCREEN_RES[0] / 8, 3 * SCREEN_RES[1] / 4), 110, False),
								DefaultGravity()],
				"wallList"   : [HWall(SCREEN_RES[0] / 4, SCREEN_RES[0], SCREEN_RES[1] / 2 - 2 * VECTOR_ARROW_SPACING)],
				"winPos"	 : roundToGap(array((7 * SCREEN_RES[0] / 8, 3 * SCREEN_RES[1] / 4))),
				}				
				
				
levelList[3] = {"diskPos"    : ((SCREEN_RES[0] / 2, BORDER_WIDTH + DISK_RADIUS),),
				"objectList" : [Spinner((SCREEN_RES[0] / 2 - 2 * VECTOR_ARROW_SPACING, 3 * VECTOR_ARROW_SPACING), 140, True, False),
								Spinner((SCREEN_RES[0] / 2 + 2 * VECTOR_ARROW_SPACING, 3 * VECTOR_ARROW_SPACING), 140, False, False),
								GravityWell((SCREEN_RES[0] / 2, 3 * SCREEN_RES[1] / 4), 140, False),
								DefaultGravity()],
				"wallList"   : [VWall(SCREEN_RES[0] / 2 - 3 * VECTOR_ARROW_SPACING / 2, 0, SCREEN_RES[1] / 2),
								VWall(SCREEN_RES[0] / 2 + 3 * VECTOR_ARROW_SPACING / 2, 0, SCREEN_RES[1] / 2),
								HWall(SCREEN_RES[0] / 4, 3 * SCREEN_RES[0] / 4, 2 * SCREEN_RES[1] / 3),
								VWall(SCREEN_RES[0] / 2 - 3 * VECTOR_ARROW_SPACING / 2, SCREEN_RES[1] - 2 * VECTOR_ARROW_SPACING, SCREEN_RES[1]),
								VWall(SCREEN_RES[0] / 2 + 3 * VECTOR_ARROW_SPACING / 2, SCREEN_RES[1] - 2 * VECTOR_ARROW_SPACING, SCREEN_RES[1]),
								],
				"winPos"	 : roundToGap(array((SCREEN_RES[0] / 2, SCREEN_RES[1] - VECTOR_ARROW_SPACING))),
				}					
		
		
		
		
		
		
		
		